package com.hzya.frame.plugin.businessData.plugin;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.plugin.businessData.service.IBusinessService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 主数据同步
 *
 * @author makejava
 * @since 2024-06-21 13:52:35
 */
public class BusinessPluginInitializer extends PluginBaseEntity{
    Logger logger = LoggerFactory.getLogger(BusinessPluginInitializer.class);

    @Autowired
    private IBusinessService businessService;

      @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "BusinessPlugin";
    }

    @Override
    public String getPluginName() {
        return "BusinessPlugin插件";
    }

    @Override
    public String getPluginLabel() {
        return "BusinessPlugin";
    }

    @Override
    public String getPluginType() {
        return "1";
    }
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
        try {
            logger.info("======开始执行主数据信息同步========");
            return businessService.getBusinessData(requestJson);
        }catch (Exception e){
            logger.info("======执行主数据同步失败:{}========",e.getMessage());
            e.printStackTrace();
        }
        return null;
    }
}
