package com.hzya.frame.plugin.payables.plugin;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.sysnew.payables.service.IPayablesService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

public class PayablesPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(PayablesPluginInitializer.class);
    @Autowired
    private IPayablesService payablesService;

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "PayablesPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "应付单抽取";
    }

    @Override
    public String getPluginLabel() {
        return "PayablesPluginInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
        try {
            logger.info("======开始执行应付单同步========");
            return payablesService.queryPayables(requestJson);
        }catch (Exception e){
            logger.info("======执行应付单失败:{}========",e.getMessage());
            e.printStackTrace();
        }
        return null;
    }
}
