package com.hzya.frame.plugin.salesContract.dao;

import com.hzya.frame.basedao.dao.IBaseDao;
import com.hzya.frame.plugin.salesContract.entity.SalesContractEntity;

import java.util.List;

public interface ISalesContractDao extends IBaseDao<SalesContractEntity,String> {

    /**
     *
     * @content 查询未推送的销售合同
     * @Param
     * @Return
     * @Author hecan
     * @Date 2025-04-03 11:07
     * **/
    List<SalesContractEntity> querySalesContract(SalesContractEntity salesContractEntity);

    /**
     *
     * @content 更新销售合同的推送标识
     * @Param
     * @Return
     * @Author hecan
     * @Date 2025-04-03 11:09
     * **/
    Integer updateSalesContract(SalesContractEntity entity);

    /**
     *
     * @content 查询未上传文件的销售合同
     * @Param
     * @Return
     * @Author hecan
     * @Date 2025-04-16 14:40
     * **/
    List<SalesContractEntity> queryContractAnnexFile(SalesContractEntity salesContractEntity);

    /**
     *
     * @content 查询未上传文件的销售合同IPO附件
     * @Param
     * @Return
     * @Author hecan
     * @Date 2025-04-16 14:40
     * **/
    List<SalesContractEntity> queryIPOAnnexFile(SalesContractEntity salesContractEntity);

    /**
     *
     * @content 更新销售合同附件和ipo附件上传标识
     * @Param
     * @Return
     * @Author hecan
     * @Date 2025-04-16 16:48
     * **/
    Integer updateAnnexFile(SalesContractEntity entity);
}
