package com.hzya.frame.plugin.salesContract.plugin;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.dateutil.DateUtil;
import com.hzya.frame.plugin.salesContract.dao.ISalesContractDao;
import com.hzya.frame.plugin.salesContract.entity.SalesContractEntity;
import com.hzya.frame.seeyon.util.OARestUtil;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import java.io.File;
import java.io.FileInputStream;
import java.util.Base64;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

public class ContractAnnexFileUploadPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(ContractAnnexFileUploadPluginInitializer.class);

    @Autowired
    private ISalesContractDao salesContractDao;

    @Autowired
    private IIntegrationTaskLivingDetailsService taskLivingDetailsService;

    @Value("${zt.url}")
    private String url;

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "ContractAnnexFileUploadPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "销售合同附件上传";
    }

    @Override
    public String getPluginLabel() {
        return "ContractAnnexFileUploadPluginInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson)  {
        try {
            logger.info("======开始执行销售合同附件上传BIP========");
            //重试方法
            if (null != requestJson) {
                //如果这个id不为空，说明是重试的
                String id = requestJson.getString("integration_task_living_details_id");
                //执行重新发送
                SalesContractEntity salesContractEntity = new SalesContractEntity();
                salesContractEntity.setDataSourceCode("SW-OA");
                if (StrUtil.isNotEmpty(id)) {
                    salesContractEntity.setId(id);
                }
                //查询未上传的数据
                List<SalesContractEntity> salesContractEntities = salesContractDao.queryContractAnnexFile(salesContractEntity);
                if(salesContractEntities == null || salesContractEntities.size() == 0){
                    logger.info("=====没有需要上传BIP的销售合同附件==========");
                    return BaseResult.getSuccessMessageEntity("查询成功");
                }
                JSONObject resultJson=null;
                SalesContractEntity salesContract=new SalesContractEntity();
                salesContract.setDataSourceCode("SW-OA");
                for (SalesContractEntity contractEntity : salesContractEntities) {
                    if(null !=contractEntity.getHtnrfilename() && null==contractEntity.getHtnrpush()){
                        contractEntity.setDataSourceCode("SW-OA");
                        JSONArray jsonArray=new JSONArray();
                        JSONObject jsonObject=new JSONObject();
                        jsonObject.put("filename",contractEntity.getHtnrfilename());
                        jsonObject.put("billtype",contractEntity.getBilltype());
                        jsonObject.put("billid",contractEntity.getBillid());
                        jsonObject.put("billcode",contractEntity.getBillcode());
                        jsonObject.put("pk_org",contractEntity.getPkOrg());
                        String file_url = contractEntity.getHtnrid();
                        String newPath = "E:\\yongansystem\\upload\\reuce\\"+contractEntity.getHtnrfilename();
                        downOaFile(file_url,contractEntity.getHtnrfilename(),newPath);
                       //本地文件转为base64
                        String base64 = getBase64(newPath);
                        jsonObject.put("file",base64);
                        jsonArray.add(jsonObject);
                         resultJson = send(jsonArray, contractEntity);
                        logger.error("销售合同附件上传BIP返回结果：" + resultJson.toJSONString());
                        salesContract.setId(contractEntity.getId());
                    }
                }
                if(null !=resultJson ){
                    if(!resultJson.getBoolean("flag")){
                        logger.info("=========销售合同附件上传bip返回结果错误，开始修改销售合同附件上传推送标识为失败==========");
                        salesContract.setHtnrpush("0");
                        salesContractDao.updateAnnexFile(salesContract);
                        logger.info("=========销售合同附件上传获取bip返回结果错误，修改销售合同附件上传推送标识为失败完毕==========");
                        // saveTaskLivingDetails(contractEntity.getId(),contractEntity.getBillcode(),jsonObject.toString(),resultJson.toJSONString(),false);
                    }else {
                        logger.info("=========销售合同附件上传bip返回结果成功，开始修改销售合同附件上传推送标识为成功==========");
                        salesContract.setHtnrpush("1");
                        salesContractDao.updateAnnexFile(salesContract);
                        logger.info("=========销售合同附件上传bip返回结果成功，修改销售合同附件上传推送标识为成功完毕==========");
                        // saveTaskLivingDetails(contractEntity.getId(),contractEntity.getBillcode(),jsonObject.toString(),resultJson.toJSONString(),true);
                    }
                }else{
                    logger.info("=======没有销售合同附件上传BIP=======");
                }
                logger.info("=======销售合同附件上传BIP执行成功=======");
                return BaseResult.getSuccessMessageEntity("销售合同附件上传执行成功");
            }
        }catch (Exception e){
            logger.info("======执行销售合同附件上传BIP失败:{}========", e.getMessage());
            e.printStackTrace();
        }
        return null;
    }

    private void downOaFile(String fileUrl, String fileName,String newPath) {
        logger.info("开始下载附件"+newPath);
        String token = getToken();
        logger.info("获取的token信息");
        String baseUrl = "https://swoa.sunwave.com.cn:9999/seeyon/rest/attachment/file/"+fileUrl+"?fileName="+fileName+"&token="+token;
        logger.info("要下载附件的URL"+baseUrl);
        HttpResponse response = HttpRequest.get(baseUrl).timeout(20000).execute();
        File uploadFile = new File(newPath);
        response.writeBody(uploadFile);
    }

    private String getToken() {
        JSONObject jsonObject = new JSONObject();
        HashMap<String,String> hashMap = new HashMap<>();
        hashMap.put("userName","hzyaRestUser");
        hashMap.put("password","hzya1314");
        hashMap.put("loginName","fkmanager");
        String result = HttpUtil.post("https://swoa.sunwave.com.cn:9999/seeyon/rest/token", JSON.toJSONString(hashMap));
        jsonObject = JSONObject.parseObject(result);
        if("".equals(result) || result == null){
            logger.info("获取token失败！");
            throw new RuntimeException("获取token失败！");
        }else{
            String token = jsonObject.get("id").toString();
            return token ;
        }
    }

    //将本地文件转为base64编码
    private String getBase64(String filePath) {
        File file = new File(filePath);
       try {
           FileInputStream fileInputStream = new FileInputStream(file);
           byte[] bytes = new byte[(int) file.length()];
           fileInputStream.read(bytes);
           return Base64.getEncoder().encodeToString(bytes);
       }catch (Exception e){
           logger.info("========文件转base64失败:{}=====",e.getMessage());
           e.printStackTrace();
       }
       return null;
    }

    private JSONObject send(JSONArray jsonArray,SalesContractEntity contractEntity){
        if(CollectionUtils.isNotEmpty(jsonArray)) {
                JSONObject token = new JSONObject();
                //获取TOKEN
                String tokenResult = HttpRequest.post(url).
                        header("appId", "800050").
                        header("apiCode", "8000500003").
                        header("publicKey", "ZJYAQ/VtQ66PqKXlV0EowrrlKkhBHYgS/Zk39Q5ezIQne51Ce7eDIk+3zDUT+v578prj").
                        header("secretKey", "iLLk424Bmzknbu+ROeJoiVDMYY5EFXtbZY/aU13HmVYIiQrIw9c0Ag4ipxbfpUqqj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=").
                        body(token.toString()).
                        execute().
                        body();
                logger.error("销售合同附件上传BIPtoken返回结果：" + tokenResult);
                JSONObject tokenResultJson = JSONObject.parseObject(tokenResult);
                if (!tokenResultJson.getBoolean("flag")) {
                    logger.info("=========销售合同上传附件获取biptoken错误，开始修改销售合同附件上传推送标识为失败==========");
                    contractEntity.setIpopush("0");
                    contractEntity.setHtnrpush("0");
                    salesContractDao.updateAnnexFile(contractEntity);
                    logger.info("=========销售合同附件上传获取biptoken错误，修改销售合同附件上传推送标识完毕==========");
                    return null;
                }
                String tokenBody = tokenResultJson.getJSONObject("attribute").getJSONObject("data").getString("access_token");
                logger.error("销售合同附件上传推送BIP请求参数：" + JSON.toJSONString(jsonArray));
                //发送数据
                String result = HttpRequest.post(url).
                        header("appId", "800050").
                        header("apiCode", "8000500022").
                        header("access_token", tokenBody).
                        header("publicKey", "ZJYAQ/VtQ66PqKXlV0EowrrlKkhBHYgS/Zk39Q5ezIQne51Ce7eDIk+3zDUT+v578prj").
                        header("secretKey", "iLLk424Bmzknbu+ROeJoiVDMYY5EFXtbZY/aU13HmVYIiQrIw9c0Ag4ipxbfpUqqj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=").
                        body(JSON.toJSONString(jsonArray)).
                        execute().
                        body();
                JSONObject resultJson = JSONObject.parseObject(result);
                return resultJson;
            }
        return null;
    }

    private void saveTaskLivingDetails(String rootAppPk,String rootAppBill,String rootAppNewData,String newTransmitInfo,boolean flag) {
        try {
            IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity = new IntegrationTaskLivingDetailsEntity();
            integrationTaskLivingDetailsEntity.setId(UUIDUtils.getUUID());
            integrationTaskLivingDetailsEntity.setSts("Y");
            integrationTaskLivingDetailsEntity.setCreate_user_id("1");
            integrationTaskLivingDetailsEntity.setModify_user_id("1");
            integrationTaskLivingDetailsEntity.setCreate_time(new Date());
            integrationTaskLivingDetailsEntity.setModify_time(new Date());
            integrationTaskLivingDetailsEntity.setOrg_id("0");
            integrationTaskLivingDetailsEntity.setCompanyId("0");
            integrationTaskLivingDetailsEntity.setRootAppPk(rootAppPk);
            integrationTaskLivingDetailsEntity.setRootAppBill(rootAppBill);
            integrationTaskLivingDetailsEntity.setPluginId("SalesContractPluginInitializer");
            integrationTaskLivingDetailsEntity.setRootAppNewData(rootAppNewData);
            integrationTaskLivingDetailsEntity.setNewTransmitInfo(newTransmitInfo);
            if (flag) {
                taskLivingDetailsService.saveLogToSuccess(integrationTaskLivingDetailsEntity);
            } else {
                taskLivingDetailsService.saveLogToFail(integrationTaskLivingDetailsEntity);
            }
        } catch (Exception e) {
            logger.info("保存日志到集成任务日志明细中失败:{}", e.getMessage());
        }
    }
}
