package com.hzya.frame.plugin.serviceData.plugin;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.seeyon.paybill.service.IPayBillService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.annotation.Resource;

/**
 * 业务数据同步
 *
 * @author makejava
 * @since 2024-06-21 13:52:35
 */
public class PayReceivedPluginInitializer extends PluginBaseEntity{
    Logger logger = LoggerFactory.getLogger(PayReceivedPluginInitializer.class);


    @Resource
    private IPayBillService payBillService;
      @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "PayReceivedPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "业务数据抽取";
    }

    @Override
    public String getPluginLabel() {
        return "PayReceivedPluginInitializer";
    }

    @Override
    public String getPluginType() {
        return "1";
    }
    /**
     *
     * @content 付款申请单SW-D同步更新BIP
     * @className: Administrator
     * @author laborer
     * @date 2025-04-17 9:08
     *
     */

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
        try {
            logger.info("======开始执行业务数据信息同步========");
            return payBillService.sendPayReceivedToBip(requestJson);
        }catch (Exception e){
            logger.info("======执行业务数据同步失败:{}========",e.getMessage());
            e.printStackTrace();
        }
        return BaseResult.getSuccessMessageEntity("操作成功");
    }
}
