package com.hzya.frame.sysnew.payables.dao.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.dao.MybatisGenericDao;
import com.hzya.frame.execsql.service.IExecSqlService;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.sysnew.payables.dao.IPayablesDao;
import com.hzya.frame.sysnew.payables.entity.PayablesEntity;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;

@Repository(value = "PayablesDaoImpl")
public class PayablesDaoImpl extends MybatisGenericDao<PayablesEntity,String> implements IPayablesDao {
    @Autowired
    private IExecSqlService execSqlService;

    private Logger logger = LogManager.getLogger(super.getClass());

    @DS("#entity.dataSourceCode")
    @Override
    public List<HashMap<String, Object>> queryListByPayables(String str, MdmModuleSourceEntity entity) {
        try {
            List<HashMap<String, Object>> hashMaps = execSqlService.execSelectSql(str, "");
            return hashMaps;
        }catch (Exception e){
            logger.info("三维应付单中没有需要同步中台的数据");
            return null;
        }
    }
}
