package com.hzya.frame.seeyon.paybill.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.seeyon.cbs8.entity.PaymentEntity;
import com.hzya.frame.seeyon.paybill.dao.IPayBillDao;
import com.hzya.frame.seeyon.paybill.entity.PayBillEntity;
import com.hzya.frame.seeyon.paybill.service.IPayBillService;
import com.hzya.frame.seeyon.service.impl.SeeYonInterFaceImpl;
import com.hzya.frame.seeyon.util.OABipUtil;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.jetbrains.annotations.NotNull;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 *
 * @content 付款单同步BIP
 * @author laborer
 * @date 2024/6/20 0020 15:20
 *
 */

@Service("PayBillServiceImpl")
public class PayBillServiceImpl extends BaseService<PaymentEntity,String> implements IPayBillService {
    private static final Logger logger = LoggerFactory.getLogger(PayBillServiceImpl.class);

    @Autowired
    private IPayBillDao payBillDao;
    /**
     *
     * @content 工程付款单数据同步BIP
     * @author laborer
     * @date 2024/6/20 0020 11:24
     *
     */
    @Override
    public JsonResultEntity sendEngineerPayBillToBip(JSONObject requestJson) {
//        PayBillEntity entity = new PayBillEntity();
//        requestJson.put("db_code","OA");
//        entity.setDataSourceCode(requestJson.getString("db_code"));
//        List<PayBillEntity>payBillEntityList = payBillDao.getOaEngineerPay(entity);
//        if(CollectionUtils.isNotEmpty(payBillEntityList)){
//            for(PayBillEntity pay : payBillEntityList){
//                PayBillEntity details = new PayBillEntity();
//                List<PayBillEntity>payDetailsList = payBillDao.getOaEngineerPayDetails(details);
//
//                String token = OABipUtil.getBipToken("yonyou","8000230000");
//                JSONObject main = bindingAdd(pay);
//                logger.info("工程付款单调用中台生成BIP付款结算单推送报文{}",main.toString());
//                String result = OABipUtil.sendOATOBipEsb(main.toString(),"8000230014",token);
//                logger.info("工程付款单调用中台生成BIP付款结算单返回结果{}",result);
//                JSONObject resultObj = JSON.parseObject(result);
//                boolean flag = resultObj.getBoolean("success");
//                if(flag){
//                    pay.setState("Y");
//                }else{
//                    pay.setState("N");
//                }
//                pay.setDataSourceCode(requestJson.getString("db_code"));
//                payBillDao.updateState(pay);
//                // todo 后续在写吧（没字段等OA开了外网在创建），修改推送状态，避免再次查询
//            }
//        }
        return null;
    }

    @Override
    public JsonResultEntity sendMarginPaymentToBip(JSONObject requestJson) {
        PayBillEntity entity = new PayBillEntity();
        requestJson.put("db_code","SW-OA");
        entity.setDataSourceCode(requestJson.getString("db_code"));
        List<PayBillEntity>payBillEntityList = payBillDao.getMarginPayment(entity);
        if(CollectionUtils.isNotEmpty(payBillEntityList)){
            for(PayBillEntity pay : payBillEntityList){
                String datasourceCode = requestJson.getString("db_code");
                System.out.println("更新时的数据源编码为"+datasourceCode);
                logger.info("更新时的数据源编码为"+datasourceCode);
                pay.setDataSourceCode(datasourceCode);
                try {
//                    PayBillEntity details = new PayBillEntity();
//                    details.setFormmain_id(pay.getId());
//                    details.setDataSourceCode(requestJson.getString("db_code"));
//                    List<PayBillEntity>payDetailsList = payBillDao.getOaEngineerPayDetails(details);
                    String token = OABipUtil.getBipToken("yonyou","8000500003");
//                    pay.setPayBillDetailsEntityList(payDetailsList);
                    JSONObject main = bindingMarginAdd(pay);
                    logger.info("保证金原始报文{}",JSON.toJSONString(pay));
                    logger.info("保证金付款申请单推送BIP报文{}",main.toString());
                    String result = OABipUtil.sendOATOBipEsb(main.toString(),"8000500007",token);
                    logger.info("保证金付款申请单推送BIP报文返回结果{}",result);
                    JSONObject resultObj = JSON.parseObject(result);
                    String resultFlag = resultObj.getString("Result");
                    if("success".equals(resultFlag)){
                        pay.setState("Y");
                    }else{
                        pay.setState("N");
                    }

                    payBillDao.updateState(pay);
                } catch (Exception e) {
                    pay.setState("N");
                    payBillDao.updateState(pay);
                    logger.error("保证金同步BIP保证金付款失败，请联系管理员:{}",e);
                }

            }
        }
        return null;
    }

    @Override
    public JsonResultEntity sendReceivedToBip(JSONObject requestJson) {
        PayBillEntity entity = new PayBillEntity();
        requestJson.put("db_code","SW-OA");
        entity.setDataSourceCode(requestJson.getString("db_code"));
        List<PayBillEntity>payBillEntityList = payBillDao.getReceived(entity);
        if(CollectionUtils.isNotEmpty(payBillEntityList)){
            for(PayBillEntity pay : payBillEntityList){
                pay.setDataSourceCode(requestJson.getString("db_code"));
                try {
                    boolean flag = true;
                    StringBuffer sb = new StringBuffer();
//                    PayBillEntity details = new PayBillEntity();
//                    details.setFormmain_id(pay.getId());
//                    details.setDataSourceCode(requestJson.getString("db_code"));
//                    List<PayBillEntity>payDetailsList = payBillDao.getReceivedDetails(details);
                    String token = OABipUtil.getBipToken("yonyou","8000500003");
//                pay.setPayBillDetailsEntityList(payDetailsList);
                    //组装更新保证金还款信息
                    JSONObject main = bindingReceivedAdd(pay);
                    logger.info("保证金付款申请单-还款推送BIP报文{}",main.toString());
                    String result = OABipUtil.sendOATOBipEsb(main.toString(),"8000500015",token);
                    logger.info("保证金付款申请单-还款推送BIP报文返回结果{}",result);
                    JSONObject resultObj = JSON.parseObject(result);
                    flag = resultObj.getBoolean("Result");
                    if(!flag){
                        sb.append("更新保证金还款信息失败：错误原因"+resultObj.getString("Message")+pay.getReceiptDetailsId() +"  ");
                        pay.setState("N");
                    }else{
                        pay.setState("Y");
                    }

                    //不单独更新数据到表中了，记录日志用
                    logger.info("保证金流程结束事件出错"+sb.toString());
                    payBillDao.updateState(pay);
                } catch (Exception e) {
                    pay.setState("N");
                    payBillDao.updateState(pay);
                    logger.info("保证金流程结束事件出错，请联系管理员:"+e);
                    logger.info("保证金流程结束事件出错，请联系管理员1:"+e.getMessage());

                }
            }
        }
        return null;
    }

    @Override
    public JsonResultEntity sendPayReceivedToBip(JSONObject requestJson) {
        return null;
    }

//    private JSONObject bindingReceivedRLAdd(PayBillEntity pay) {
//        JSONObject head = new JSONObject();
//        head.put("c_bill_type","F9");//单据类型 保证金付款申请单固定F9
//        head.put("formCode",pay.getFormCode());//单据号
//        head.put("receiptDetailsId","");//BIP到款明细主键
//        head.put("repaymentDate","");//还款日期
//        head.put("repaymentType","");//还款类型
//        head.put("repaymentAmount","");//还款金额
//        return head;
//    }

    private JSONObject bindingReceivedAdd(PayBillEntity pay) {
        JSONObject head = new JSONObject();
        head.put("c_bill_type",pay.getC_bill_type());//单据类型 保证金付款申请单固定F9
        head.put("formCode",pay.getFormCode());//单据号
        head.put("receiptDetailsId",pay.getReceiptDetailsId());//BIP到款明细主键
        String repaymentDate = pay.getRepaymentDate();
        if(StrUtil.isNotEmpty(repaymentDate)){
            head.put("repaymentDate",DateUtil.format(DateUtil.parse(repaymentDate), "yyyy-MM-dd HH:mm:ss"));//还款日期
        }
        head.put("repaymentType",pay.getRepaymentType());//还款类型
        head.put("repaymentAmount",pay.getRepaymentAmount());//还款金额
        return head;
    }

    private JSONObject bindingMarginAdd(PayBillEntity pay) {

        JSONObject head = new JSONObject();
        head.put("c_bill_type","F9");//单据类型 保证金付款申请单固定F9
        head.put("formCode",pay.getFormCode());//单据号（NC有重复校验）
        head.put("orgCode",pay.getOrgCode());//公司编码fanc
        head.put("deptCode",pay.getDeptCode());//事业部大类编码
        head.put("fklxName",pay.getFklxName());//付款类型
        head.put("zffsName",pay.getZffsName());//支付方式
        head.put("firstSubject",pay.getFirstSubject());//一级科目
        head.put("bzjProjectName",pay.getBzjProjectName());//保证金项目名称
        String expirationDate= pay.getExpirationDate();
        if(StrUtil.isNotEmpty(expirationDate)){
            head.put("expirationDate",DateUtil.format(DateUtil.parse(expirationDate), "yyyy-MM-dd"));//投标保证金到期日
        }

        head.put("deptCode2",pay.getDeptCode2());//归属部门编码
        head.put("isCustomer","Y");//是否运营商客户
        head.put("applyAmount",pay.getApplyAmount());//申请金额
        head.put("checkedAmount",pay.getCheckedAmount());//财务核实金额
        head.put("comments",pay.getComments());//说明
        head.put("creator",pay.getCreator());//制单人
        head.put("supplierCode",pay.getSupplierCode());//供应商编码
        head.put("openBank",pay.getOpenBank());//开户银行
        head.put("bankAccount",pay.getBankAccount());//银行账号
        head.put("customerAddress",pay.getCustomerAddress());//客户地址
        head.put("linkMan",pay.getLinkMan());//联系人
        head.put("contactNumber",pay.getContactNumber());//联系电话

        head.put("bhBeneficiary",pay.getBhBeneficiary());//保函受益人
        head.put("beneficiaryPhone",pay.getBeneficiaryPhone());//受益人电话
        head.put("beneficiaryAddress",pay.getBeneficiaryAddress());//受益人地址
        head.put("projectNumber",pay.getProjectNumber());//工程项目合同/标书号码
        head.put("projectAmount",pay.getProjectAmount());//工程项目合同/标书总金额
        String bhIndate = pay.getBhIndate();
        if(StrUtil.isNotEmpty(bhIndate)){
            head.put("bhIndate",DateUtil.format(DateUtil.parse(bhIndate), "yyyy-MM-dd"));//保函有效期
        }
        head.put("bhReceiver",pay.getBhReceiver());//保函收件人
        head.put("contactType",pay.getContactType());//联系方式
        head.put("contactAddress",pay.getContactAddress());//联系地址
        head.put("bhProjectName",pay.getBhProjectName());//保函项目名称

        String lastBhDate = pay.getLastBhDate();
        if(StrUtil.isNotEmpty(lastBhDate)){
            head.put("lastBhDate",DateUtil.format(DateUtil.parse(lastBhDate), "yyyy-MM-dd"));//最晚取得保函日期
        }
        head.put("notes",pay.getNotes());//备注
        head.put("isBh",pay.getIsBh());//是否取得保函原件

        head.put("dkAmount",pay.getDkAmount());//打款金额
        String dkTime = pay.getDkTime();
        if(StrUtil.isNotEmpty(dkTime)){
            head.put("dkTime", DateUtil.format(DateUtil.parse(dkTime), "yyyy-MM-dd HH:mm:ss"));//打款时间
        }

        head.put("isDydj","Y");//是否打印本单据

        //处理明细数据，按照明细付款 多个明细生成多个付款结算单
        JSONArray detailsArr = new JSONArray();
//        List<PayBillEntity>detailsList = pay.getPayBillDetailsEntityList();
//        if(CollectionUtils.isNotEmpty(detailsList)){
//            detailsList.forEach(detail->{
//                JSONObject body = new JSONObject();
//                body.put("projectCode","");//项目编码
//                body.put("projectName","");//项目名称
//                body.put("wdContact","");//未定合同号
//                body.put("buildCost","");//工程造价
//                body.put("deptCode","");//承担部门编码
//                detailsArr.add(body);
//            });
//        }
        head.put("xmDetail",detailsArr);//明细数据
        head.put("hkDetail",detailsArr);//明细数据
        return head;
    }

    @NotNull
    private JSONObject bindingAdd(PayBillEntity pay) {
        JSONObject head = new JSONObject();
        head.put("pk_org","");//所属组织
        head.put("pk_group","");//集团
        head.put("bill_type","F5");//单据类型 默认F5
        head.put("trade_type","D5");//付款结算类型 默认D5
        head.put("source_flag","2");//付款结算类型 默认2
        head.put("bill_date",pay.getBillDate());//单据日期
        head.put("primal_money",pay.getPrimalMoney());//付款原币金额
        head.put("pk_currtype","CNY");//币种
        head.put("billmaker","");//制单人
        //处理明细数据，按照明细付款 多个明细生成多个付款结算单
        JSONArray detailsArr = new JSONArray();
        JSONObject body = new JSONObject();
        body.put("pk_org","");//所属组织
        body.put("pk_group","");//集团
        body.put("bill_type","F5");//单据类型 默认F5
        body.put("trade_type","D5");//付款结算类型 默认D5
        body.put("pk_currtype","CNY");//币种
        body.put("bill_date",pay.getBillDate());//单据日期
        body.put("pay_primal",pay.getPrimalMoney());//付款原币金额
        body.put("creationtime",pay.getBillDate());//创建时间
        body.put("direction","-1");//方向 :1=收;-1=付;
        body.put("objecttype","0");//交易对象
        body.put("pk_customer",pay.getPkCustomer());//客户
        body.put("pk_account",pay.getPkOppaccount());//付款银行账号
        detailsArr.add(body);
        JSONObject main = new JSONObject();
        main.put("head",head);//表头
        main.put("body",detailsArr);//明细数据
        return main;
    }
}
